# RubikJS

## Description

JavaScript library meant to abstract core functionality in our [beloved monolith](https://github.schibsted.io/scmspain/all-ij--web-empleo)

## Usage

### Load the script at the end of the body tag in your html file

```html
<html>
<head>
  ...
</head>
<body>
  ...
  <!-- PRE ENVS -->
  <script src="https://ij-react-components-dev.s3.amazonaws.com/rubik/[CURRENT_VERSION]/index.js"></script>
  <!-- PRO ENV -->
  <script src="https://unpkg.com/@s-ui/ij-rubik/umd/index.js"></script>
</body>
</html>
```

### Listen to `rubik:loaded` event rubik will sent once its loaded

```js
document.addEventListener('rubik:loaded', function(ev) {})
```

Now you will be able to access to `window.rubik` will all modules loaded

## Modules

<details><summary>
Analytics - AdBlockDetector
</summary>
First add this snippet to the header inside the html

```html
  <script>
    !function(){var analytics=window.analytics=window.analytics||[];if(!analytics.initialize)if(analytics.invoked)window.console&&console.error&&console.error("Segment snippet included twice.");else{analytics.invoked=!0;analytics.methods=["trackSubmit","trackClick","trackLink","trackForm","pageview","identify","reset","group","track","ready","alias","debug","page","once","off","on"];analytics.factory=function(t){return function(){var e=Array.prototype.slice.call(arguments);e.unshift(t);analytics.push(e);return analytics}};for(var t=0;t<analytics.methods.length;t++){var e=analytics.methods[t];analytics[e]=analytics.factory(e)}analytics.load=function(t,e){var n=document.createElement("script");n.type="text/javascript";n.async=!0;n.src="https://cdn.segment.com/analytics.js/v1/"+t+"/analytics.min.js";var a=document.getElementsByTagName("script")[0];a.parentNode.insertBefore(n,a);analytics._loadOptions=e};analytics.SNIPPET_VERSION="4.1.0";

    analytics.load("WRITE KEY"); // ask for the write key
    }}();
  </script>
```

#### Events

##### Identify

```js
document.addEventListener('rubik:loaded', function() {
  window.rubik.analytics.identify("userID abcd...", {
    email:"joe.ayoub@segment.com",
    first_name:"Joe",
    last_name:"Ayoub"
  });
})
```

##### Track

###### Pages

Wait for the `rubik:loaded` event before firing up the track event for pages

```js
document.addEventListener('rubik:loaded', function() {
  window.rubik.analytics.track("MyCv Experience Form Viewed",{
    page_name:"infojobs.net",
    site:"infojobs.net",
    section:"candidate",
    channel:"my account",
    platform:"web",
    vertical:"jobs",
    page_type:"form",
    status:"edit"
  })
})
```

###### Clicks

Add an `data-track` attribute with the event you want to track to any DOM element and the click will be tracked automatically

```html
  <div data-track="button clicked">track me!</div>
```

##### Reset

```js
// call this function to reset the browser cookie
document.addEventListener('rubik:loaded', function() {
  window.rubik.analytics.reset();
})
```

###### AdBlock Detector

On every library load the script will create a cookie saving whether an user has or not an ablocker installed

</details>

<details><summary>
NavOrigen
</summary>

```js
  document.addEventListener('rubik:loaded', function() {
    window.rubik.navOrigen.loadCookies()
  })
```

</details>
