const TRACK_ATTRIBUTE = 'data-track'
const PROPERTIES_ATTRIBUTE = 'data-track-properties'

const eventMap = []

const trackingCallbackFactory = el =>
  function() {
    const data = el.getAttribute(PROPERTIES_ATTRIBUTE)
    const properties = data ? JSON.parse(data.replace(/&quot;/g, '"')) : {}
    window.rubik.analytics.track(el.getAttribute(TRACK_ATTRIBUTE), properties)
  }

const listenToClicksToTrack = function(eventFn) {
  const elements = document.querySelectorAll(`[${TRACK_ATTRIBUTE}]`)

  Array.from(elements).forEach((element, idx) => {
    const callback = trackingCallbackFactory(element)
    eventMap.push({element, callback})
    element.addEventListener('click', callback)
  })
}

const removeListeners = function() {
  eventMap.forEach(({element, callback}) => {
    element.removeEventListener('click', callback)
  })
}

document.addEventListener('segment:reload', function() {
  removeListeners()
  listenToClicksToTrack()
})

export default listenToClicksToTrack
